using System;
using System.Data;
using ByteFX.Data.MySqlClient;
using System.Collections.Specialized;
using System.Xml;

namespace BusObjCS {
	public class PubsAccess{
		private string m_connStr;
		
		public PubsAccess () {}

		public PubsAccess (string connStr){
			m_connStr = connStr;
		}
		
		public string DatabaseConnection{
			set {m_connStr = value;}
			get {return m_connStr;}
		}
		
		public DataSet GetAuthors () {
			MySqlConnection dbConnection = new MySqlConnection(m_connStr);
			DataSet authors = new DataSet();
			try{
				dbConnection.Open();
				MySqlDataAdapter sqlCommand = new MySqlDataAdapter("SELECT au_id, concat(au_fname,' ',au_lname) AS au_name FROM authors", dbConnection);
				sqlCommand.Fill(authors, "authors");
			}
			catch (MySqlException ex){
				throw(ex);
			}
			finally{
				dbConnection.Close();
			}
			return authors;
		}
	
		public StringCollection GetTitlesForAuthor (string authorID){
			StringCollection collTitles = new StringCollection();
			MySqlConnection dbConnection = new MySqlConnection(m_connStr);
			DataSet titles = new DataSet();
			try{
				dbConnection.Open();
				MySqlDataAdapter sqlCommand = new MySqlDataAdapter("SELECT title FROM titles INNER JOIN titleauthor ON titles.title_id = titleauthor.title_id WHERE (au_id = '" + authorID + "')", dbConnection);
				sqlCommand.Fill(titles, "titles");
			}
			catch (MySqlException ex){
				throw(ex);
			}
			finally{
				dbConnection.Close();
			}
			DataRow[] titleRows;
			titleRows = titles.Tables["titles"].Select();
			for (int i=0; i <= titleRows.Length - 1; i++){
				collTitles.Add (titleRows[i]["title"].ToString());
			}	
			return collTitles;	
		}
		
		public int TotalSalesForAuthor (string authorID){
			MySqlConnection dbConnection = new MySqlConnection(m_connStr);
			DataSet SalesTotal = new DataSet();
			try{
				dbConnection.Open();
				MySqlDataAdapter sqlCommand = new MySqlDataAdapter("SELECT SUM(ytd_sales) AS TotalSales FROM titles INNER JOIN titleauthor ON titles.title_ID = titleauthor.title_id WHERE (au_id = '" + authorID + "')", dbConnection);
				sqlCommand.Fill(SalesTotal, "SalesTotal");
			}
			catch (MySqlException ex){
				throw(ex);
			}
			finally{
				dbConnection.Close();
			}
			
			DataTable titleTable;
			titleTable = SalesTotal.Tables["SalesTotal"];
			if (!(titleTable.Rows[0].IsNull("TotalSales"))){
				return Convert.ToInt32(titleTable.Rows[0]["TotalSales"]);	
			}
			else
				return 0;
		}
	}
}
