Option Explicit
Option Strict

Imports System
Imports System.Data
Imports ByteFX.Data.MySqlClient
Imports System.Collections.Specialized
Imports System.XML

namespace BusObjVB

	public class PubsAccess
		private m_connStr as String

		public Sub New()
			MyBase.new()
		end Sub

		public Sub New(connStr As String)
			MyBase.new()
			m_connStr = connStr
		end Sub

		public Property DatabaseConnection as String
			set
				m_connStr = value
			end set
			get
				return m_connStr
			end get
		end Property

		public function GetAuthors () as DataSet
			dim dbConnection as new MySQLConnection(m_connStr)
			dim authors as new DataSet()
			try
				dbConnection.Open()
				dim sqlCommand as new MySQLDataAdapter("SELECT au_id, concat(au_fname,' ',au_lname) AS au_name FROM authors", dbConnection)
				sqlCommand.Fill(authors, "authors")
			catch ex as MySQLException
				throw ex
			finally
				dbConnection.close()
			end try
			return authors
		end Function

		public function GetTitlesForAuthor (authorID as string) as StringCollection
			dim collTitles as new StringCollection()
			dim dbConnection as new MySQLConnection(m_connStr)
			dim titles as new DataSet()
			try
				dbConnection.Open()
				dim sqlCommand as new MySQLDataAdapter("SELECT title FROM titles INNER JOIN titleauthor ON titles.title_id = titleauthor.title_id WHERE (au_id = '" + authorID + "')", dbConnection)
				sqlCommand.Fill(titles, "titles")
			catch ex as MySQLException
				throw ex
			finally
				dbConnection.close()
			end try
			dim titleRows() as DataRow
			titleRows = titles.Tables("titles").Select()
			dim i as integer
			for i=0 to titleRows.Length - 1
				collTitles.Add (titleRows(i)("title").ToString())
				next i
			return collTitles
		end Function

		public Function TotalSalesForAuthor (authorID as string) as integer
			dim dbConnection as new MySQLConnection(m_connStr)
			dim SalesTotal as new DataSet()
			try
				dbConnection.Open()
				dim sqlCommand as new MySQLDataAdapter("SELECT SUM(ytd_sales) AS TotalSales FROM titles INNER JOIN titleauthor ON titles.title_ID = titleauthor.title_id WHERE (au_id = '" + authorID + "')", dbConnection)
				sqlCommand.Fill(SalesTotal, "SalesTotal")
			catch ex as MySQLException
				throw ex
			finally
				dbConnection.close()
			end try
			dim titleTable as DataTable
			titleTable = SalesTotal.Tables("SalesTotal")
			if not titleTable.Rows(0).IsNull("TotalSales") then
				return CInt(titleTable.Rows(0)("TotalSales"))
			else
				return 0
			end if
		end Function
	end class
end namespace